diff --git a/libinterp/corefcn/jit-typeinfo.cc b/libinterp/corefcn/jit-typeinfo.cc
--- a/libinterp/corefcn/jit-typeinfo.cc
+++ b/libinterp/corefcn/jit-typeinfo.cc
@@ -1476,11 +1928,17 @@
   binary_ops[octave_value::op_el_pow].add_overload (fn);
 
   // now for binary index operators
-  add_binary_op (index, octave_value::op_add, llvm::Instruction::Add);
+  add_binary_op (index, octave_value::op_add,
+                 llvm::Instruction::Add,
+                 GCC_JIT_BINARY_OP_PLUS);
 
   // and binary bool operators
-  add_binary_op (boolean, octave_value::op_el_or, llvm::Instruction::Or);
-  add_binary_op (boolean, octave_value::op_el_and, llvm::Instruction::And);
+  add_binary_op (boolean, octave_value::op_el_or,
+                 llvm::Instruction::Or,
+                 GCC_JIT_BINARY_OP_LOGICAL_OR);
+  add_binary_op (boolean, octave_value::op_el_and,
+                 llvm::Instruction::And,
+                 GCC_JIT_BINARY_OP_LOGICAL_AND);
 
   // now for printing functions
   print_fn.stash_name ("print");
@@ -1497,6 +1955,11 @@
     llvm::Value *zero = llvm::ConstantInt::get (index_t, 0);
     fn.do_return (builder, zero);
   }
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    b.end_with_return (gccjit_ctxt.zero (index_t_gcc));
+  }
   for_init_fn.add_overload (fn);
 
   // bounds check for for loop
@@ -1511,6 +1974,17 @@
     llvm::Value *idx = fn.argument (builder, 1);
     llvm::Value *ret = builder.CreateICmpULT (idx, nelem);
     fn.do_return (builder, ret);
+
+  }
+  {
+    gccjit::function gf = fn.gccjit_function;
+    // FIXME: is "range" a (struct range) or a (struct range *) ?
+    gccjit::rvalue nelem
+      = gf.get_param (0).access_field (field_rng_nelem);
+    gccjit::rvalue idx = gf.get_param (1);
+    gccjit::rvalue ret = idx < nelem;
+    gccjit::block b = gf.new_block ();
+    b.end_with_return (ret);
   }
   for_check_fn.add_overload (fn);
 
@@ -1531,6 +2005,18 @@
     ret = builder.CreateFAdd (base, ret);
     fn.do_return (builder, ret);
   }
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    gccjit::rvalue idx = gf.get_param (1);
+    gccjit::rvalue didx = idx.cast_to (scalar_t_gcc);
+    gccjit::rvalue rng = gf.get_param (0);
+    gccjit::rvalue base = rng.access_field (field_rng_base);
+    gccjit::rvalue inc = rng.access_field (field_rng_inc);
+    gccjit::rvalue ret = didx * inc;
+    ret = base + ret;
+    b.end_with_return (ret);
+  }
   for_index_fn.add_overload (fn);
 
   // logically true
@@ -1562,6 +2048,20 @@
     llvm::Value *ret = builder.CreateFCmpONE (fn.argument (builder, 0), zero);
     fn.do_return (builder, ret);
   }
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block initial = gf.new_block ("initial");
+    gccjit::block error = gf.new_block ("error");
+    gccjit::block normal = gf.new_block ("normal");
+    initial.add_comment ("check for NaN");
+    initial.end_with_conditional (gf.get_param (0) != gf.get_param (0),
+                                  error, normal);
+
+    error.add_call (gripe_nantl.gccjit_function);
+    error.end_with_jump (normal);
+    
+    normal.end_with_return ( gf.get_param (0) != scalar_t_gcc.zero ());
+  }
   logically_true_fn.add_overload (fn);
 
   // logically_true boolean
@@ -1595,6 +2095,20 @@
     rng = builder.CreateInsertValue (rng, nelem, 3);
     fn.do_return (builder, rng);
   }
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::rvalue base = gf.get_param (0);
+    gccjit::rvalue limit = gf.get_param (1);
+    gccjit::rvalue inc = gf.get_param (2);
+    gccjit::block b = gf.new_block ();
+    gccjit::rvalue nelem = compute_nelem.gccjit_function (base, limit, inc);
+    gccjit::lvalue rng = gf.new_local (range_t_gcc, "rng");
+    b.add_assignment (rng.access_field (field_rng_base), base);
+    b.add_assignment (rng.access_field (field_rng_limit), limit);
+    b.add_assignment (rng.access_field (field_rng_inc), inc);
+    b.add_assignment (rng.access_field (field_rng_nelem), nelem);
+    b.end_with_return (rng);
+  }
   make_range_fn.add_overload (fn);
 
   // paren_subsref
@@ -1606,7 +2120,7 @@
                                                0, jit_int, jit_int, index,
                                                index);
 
-  fn = create_internal ("()subsref", scalar, matrix, scalar);
+  fn = create_internal ("subsref", scalar, matrix, scalar);
   fn.mark_can_error ();
 
   body = fn.new_block ();
@@ -1665,10 +2179,53 @@
     merge->addIncoming (ret, success);
     fn.do_return (builder, merge);
   }
+  // gccjit implementation of subsref:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block initial = gf.new_block ("initial");
+
+    gccjit::rvalue one_idx = index_t_gcc.one ();
+    gccjit::rvalue one_int = jit_int->to_gccjit ().one ();
+
+    gccjit::rvalue mat = gf.get_param (0);
+    gccjit::rvalue idx = gf.get_param (1); // scalar
+
+    // convert index to scalar to integer, and check index >= 1
+    gccjit::rvalue int_idx = idx.cast_to (index_t_gcc);
+    gccjit::rvalue check_idx = int_idx.cast_to (scalar_t_gcc);
+    gccjit::rvalue cond0 = (idx != check_idx);
+    gccjit::rvalue cond1 = (int_idx < one_idx);
+
+    gccjit::block conv_error = gf.new_block ("conv_error");
+    gccjit::block normal = gf.new_block ("normal");
+    initial.end_with_conditional (cond0 || cond1, conv_error, normal);
+
+    // "conv_error" block:
+    conv_error.add_call (ginvalid_index.gccjit_function);
+    conv_error.end_with_return (scalar_t_gcc.zero ()); // dummy value
+
+    // "normal" block:
+    gccjit::rvalue len = mat.access_field (field_slice_len);
+    gccjit::rvalue cond = (int_idx > len);
+    gccjit::block bounds_error = gf.new_block ("bounds_error");
+    gccjit::block success = gf.new_block ("success");
+    normal.end_with_conditional (cond, bounds_error, success);
+
+    // "bounds_error" block:
+    bounds_error.add_call (gindex_range.gccjit_function,
+                           one_int, one_int, int_idx, len);
+    bounds_error.end_with_return (scalar_t_gcc.zero ()); // dummy value
+
+    // "success" block:
+    gccjit::rvalue data = mat.access_field (field_slice_data);
+    gccjit::rvalue gep = data[int_idx];
+    gccjit::rvalue ret = gep;
+    success.end_with_return (ret);
+  }
   paren_subsref_fn.add_overload (fn);
 
   // paren subsasgn
-  paren_subsasgn_fn.stash_name ("()subsasgn");
+  paren_subsasgn_fn.stash_name ("subsasgn");
 
   jit_function resize_paren_subsasgn
     = create_external (JIT_FN (octave_jit_paren_subsasgn_impl), matrix, matrix,
@@ -1737,6 +2294,59 @@
     merge->addIncoming (mat, success);
     fn.do_return (builder, merge);
   }
+  // gccjit implementation of octave_jit_paren_subsasgn:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block initial = gf.new_block ("initial");
+    gccjit::rvalue one_idx = index_t_gcc.one ();
+    gccjit::rvalue one_int = jit_int->to_gccjit ().one ();
+
+    gccjit::lvalue mat = gf.get_param (0);
+    gccjit::rvalue idx = gf.get_param (1);
+    gccjit::rvalue value = gf.get_param (2);
+    gccjit::rvalue int_idx = idx.cast_to (index_t_gcc);
+    gccjit::rvalue check_idx = int_idx.cast_to (scalar_t_gcc);
+    gccjit::rvalue cond0 = (idx != check_idx);
+    gccjit::rvalue cond1 = (int_idx < one_idx);
+    gccjit::rvalue cond = (cond0 || cond1);
+
+    gccjit::block conv_error = gf.new_block ("conv_error");
+    gccjit::block normal = gf.new_block ("normal");
+    initial.end_with_conditional (cond, conv_error, normal);
+
+    // block: conv_error
+    conv_error.add_call (ginvalid_index.gccjit_function);
+    conv_error.end_with_return (mat);
+
+    // block: normal
+    gccjit::rvalue len = mat.access_field (field_slice_len);
+    cond0 = (int_idx > len);
+
+    gccjit::rvalue rcount = mat.access_field (field_ref_count);
+    rcount = rcount.dereference ();
+    cond1 = rcount > one_int;
+    cond = (cond0 || cond1);
+
+    gccjit::block bounds_error = gf.new_block ("bounds_error");
+    gccjit::block success = gf.new_block ("success");
+    normal.end_with_conditional (cond, bounds_error, success);
+
+    // block: bounds_error
+    // resize on out of bounds access
+    std::vector<gccjit::rvalue> args (3);
+    args[0] = mat;
+    args[1] = int_idx;
+    args[2] = value;
+    gccjit::rvalue resize_result =
+      resize_paren_subsasgn.call (gccjit_ctxt, bounds_error, args);
+    bounds_error.end_with_return (resize_result);
+
+    // block: success
+    gccjit::rvalue data = mat.access_field (field_slice_data);
+    gccjit::lvalue gep = data[int_idx];
+    success.add_assignment (gep, value);
+    success.end_with_return (mat);
+  }
   paren_subsasgn_fn.add_overload (fn);
 
   fn = create_external (JIT_FN (octave_jit_paren_subsasgn_matrix_range), matrix,
@@ -1753,6 +2363,14 @@
     llvm::Value *ret = builder.CreateExtractValue (mat, 2);
     fn.do_return (builder, builder.CreateSIToFP (ret, scalar_t));
   }
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::rvalue mat = gf.get_param (0);
+    // FIXME: is this the right behavior?
+    gccjit::rvalue ret = mat.access_field (field_slice_len);
+    gccjit::block b = gf.new_block ();
+    b.end_with_return (ret.cast_to (scalar_t_gcc));
+  }
   end1_fn.add_overload (fn);
 
   end_fn.stash_name ("end");
@@ -1811,6 +2429,13 @@
     llvm::Value *zero = llvm::ConstantFP::get (scalar_t, 0);
     fn.do_return (builder, complex_new (fn.argument (builder, 0), zero));
   }
+  // gccjit implementation of octave_jit_cast_complex_scalar:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    gccjit::rvalue zero = scalar_t_gcc.zero ();
+    b.end_with_return (complex_new (b, gf.get_param (0), zero));
+  }
   casts[complex->type_id ()].add_overload (fn);
 
   // cast scalar <- complex
@@ -1818,6 +2443,11 @@
   body = fn.new_block ();
   builder.SetInsertPoint (body);
   fn.do_return (builder, complex_real (fn.argument (builder, 0)));
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    b.end_with_return (complex_real (gf.get_param (0)));
+  }
   casts[scalar->type_id ()].add_overload (fn);
 
   // cast any <- any
@@ -1845,7 +2475,9 @@
   register_generic ("cos", matrix, matrix);
 
   add_builtin ("exp");
-  register_intrinsic ("exp", llvm::Intrinsic::exp, scalar, scalar);
+  // FIXME: looks like a typo: "cos" here should be "exp":
+  // filed as http://savannah.gnu.org/bugs/index.php?41560
+  register_intrinsic ("exp", llvm::Intrinsic::cos, scalar, scalar);
   register_generic ("exp", matrix, matrix);
 
   add_builtin ("balance");
@@ -1860,10 +2492,13 @@
   add_builtin ("norm");
   register_generic ("norm", scalar, matrix);
 
+  //FIXME: gccjit can't yet cope with duplicate names
+#if 0
   add_builtin ("rand");
   register_generic ("rand", matrix, scalar);
   register_generic ("rand", matrix, std::vector<jit_type *> (2, scalar));
 
+
   add_builtin ("magic");
   register_generic ("magic", matrix, scalar);
   register_generic ("magic", matrix, std::vector<jit_type *> (2, scalar));
@@ -1871,6 +2506,7 @@
   add_builtin ("eye");
   register_generic ("eye", matrix, scalar);
   register_generic ("eye", matrix, std::vector<jit_type *> (2, scalar));
+#endif
 
   add_builtin ("mod");
   register_generic ("mod", scalar, std::vector<jit_type *> (2, scalar));
@@ -1897,6 +2533,8 @@
       casts[btype->type_id ()].add_overload (jit_function (any_id, btype,
                                                            args));
     }
+
+  gccjit_ctxt.dump_to_file ("/tmp/jit-typeinfo-dump.c", true);
 }
 
 const jit_function&
@@ -1910,10 +2548,23 @@
 }
 
 jit_type*
-jit_typeinfo::new_type (const std::string& name, jit_type *parent,
-                        llvm::Type *llvm_type, bool skip_paren)
+jit_typeinfo::new_type (const std::string& name, jit_type *parent
+#ifdef HAVE_LLVM
+                        , llvm::Type *llvm_type
+#endif
+#ifdef HAVE_GCCJIT
+                        , gccjit::type gccjit_type
+#endif
+                        , bool skip_paren)
 {
-  jit_type *ret = new jit_type (name, parent, llvm_type, skip_paren, next_id++);
+  jit_type *ret = new jit_type (name, parent
+#ifdef HAVE_LLVM
+                        , llvm_type
+#endif
+#ifdef HAVE_GCCJIT
+                        , gccjit_type
+#endif
+                                , skip_paren, next_id++);
   id_to_type.push_back (ret);
   return ret;
 }
@@ -1930,14 +2581,18 @@
 
 // FIXME: cp between add_binary_op, add_binary_icmp, and add_binary_fcmp
 void
-jit_typeinfo::add_binary_op (jit_type *ty, int op, int llvm_op)
+jit_typeinfo::add_binary_op (jit_type *ty, int op,
+                             int llvm_op,
+                             enum gcc_jit_binary_op gccjit_op)
 {
   std::stringstream fname;
   octave_value::binary_op ov_op = static_cast<octave_value::binary_op>(op);
-  fname << "octave_jit_" << octave_value::binary_op_as_string (ov_op)
+  fname << "octave_jit_" << octave_value::binary_op_fcn_name (ov_op)
         << "_" << ty->name ();
 
   jit_function fn = create_internal (fname.str (), ty, ty, ty);
+
+  // LLVM implementation:
   llvm::BasicBlock *block = fn.new_block ();
   builder.SetInsertPoint (block);
   llvm::Instruction::BinaryOps temp
@@ -1946,18 +2601,33 @@
   llvm::Value *ret = builder.CreateBinOp (temp, fn.argument (builder, 0),
                                           fn.argument (builder, 1));
   fn.do_return (builder, ret);
+
+  // gccjit implementation:
+  gccjit::function gf = fn.gccjit_function;
+  gccjit::block b = gf.new_block ();
+  b.end_with_return (
+    gf.get_context ().new_binary_op (
+      gccjit_op,
+      ty->to_gccjit (),
+      gf.get_param (0),
+      gf.get_param (1)));                              
+
   binary_ops[op].add_overload (fn);
 }
 
 void
-jit_typeinfo::add_binary_icmp (jit_type *ty, int op, int llvm_op)
+jit_typeinfo::add_binary_icmp (jit_type *ty, int op,
+                               int llvm_op,
+                               enum gcc_jit_comparison gccjit_op)
 {
   std::stringstream fname;
   octave_value::binary_op ov_op = static_cast<octave_value::binary_op>(op);
-  fname << "octave_jit" << octave_value::binary_op_as_string (ov_op)
+  fname << "octave_jit_" << octave_value::binary_op_fcn_name (ov_op)
         << "_" << ty->name ();
 
   jit_function fn = create_internal (fname.str (), boolean, ty, ty);
+
+  // LLVM implementation:
   llvm::BasicBlock *block = fn.new_block ();
   builder.SetInsertPoint (block);
   llvm::CmpInst::Predicate temp
@@ -1965,18 +2635,32 @@
   llvm::Value *ret = builder.CreateICmp (temp, fn.argument (builder, 0),
                                          fn.argument (builder, 1));
   fn.do_return (builder, ret);
+
+  // gccjit implementation:
+  gccjit::function gf = fn.gccjit_function;
+  gccjit::block b = gf.new_block ();
+  b.end_with_return (
+    gf.get_context ().new_comparison (
+      gccjit_op,
+      gf.get_param (0),
+      gf.get_param (1)));                              
+
   binary_ops[op].add_overload (fn);
 }
 
 void
-jit_typeinfo::add_binary_fcmp (jit_type *ty, int op, int llvm_op)
+jit_typeinfo::add_binary_fcmp (jit_type *ty, int op,
+                               int llvm_op,
+                               enum gcc_jit_comparison gccjit_op)
 {
   std::stringstream fname;
   octave_value::binary_op ov_op = static_cast<octave_value::binary_op>(op);
-  fname << "octave_jit" << octave_value::binary_op_as_string (ov_op)
+  fname << "octave_jit_" << octave_value::binary_op_fcn_name (ov_op)
         << "_" << ty->name ();
 
   jit_function fn = create_internal (fname.str (), boolean, ty, ty);
+
+  // LLVM implementation:
   llvm::BasicBlock *block = fn.new_block ();
   builder.SetInsertPoint (block);
   llvm::CmpInst::Predicate temp
@@ -1984,15 +2668,25 @@
   llvm::Value *ret = builder.CreateFCmp (temp, fn.argument (builder, 0),
                                          fn.argument (builder, 1));
   fn.do_return (builder, ret);
+
+  // gccjit implementation:
+  gccjit::function gf = fn.gccjit_function;
+  gccjit::block b = gf.new_block ();
+  b.end_with_return (
+    gf.get_context ().new_comparison (
+      gccjit_op,
+      gf.get_param (0),
+      gf.get_param (1)));                              
+
   binary_ops[op].add_overload (fn);
 }
 
 jit_function
-jit_typeinfo::create_function (jit_convention::type cc, const llvm::Twine& name,
+jit_typeinfo::create_function (jit_convention::type cc, std::string name,
                                jit_type *ret,
                                const std::vector<jit_type *>& args)
 {
-  jit_function result (module, cc, name, ret, args);
+  jit_function result (module, gccjit_ctxt, cc, name, ret, args);
   return result;
 }
 
@@ -2009,15 +2703,24 @@
       name << "id_" << type->name ();
 
       jit_function fn = create_internal (name.str (), type, type);
+
+      // LLVM implementation:
       llvm::BasicBlock *body = fn.new_block ();
       builder.SetInsertPoint (body);
       fn.do_return (builder, fn.argument (builder, 0));
+
+       // gccjit implementation:
+      gccjit::function gf = fn.gccjit_function;
+      gccjit::block b = gf.new_block ();
+      b.end_with_return (gf.get_param (0));
+
       return identities[id] = fn;
     }
 
   return identities[id];
 }
 
+#ifdef HAVE_LLVM
 llvm::Value *
 jit_typeinfo::do_insert_error_check (llvm::IRBuilderD& abuilder)
 {
@@ -2031,11 +2734,27 @@
   val->setVolatile (true);
   return abuilder.CreateICmpSGT (val, abuilder.getInt32 (0));
 }
+#endif /* #ifdef HAVE_LLVM */
+
+#ifdef HAVE_GCCJIT
+gccjit::rvalue
+jit_typeinfo::do_insert_error_check (gccjit::function func)
+{
+  return error_state_gccjit.cast_to (gccjit_ctxt.get_type (GCC_JIT_TYPE_BOOL));
+}
+
+gccjit::rvalue
+jit_typeinfo::do_insert_interrupt_check (gccjit::function func)
+{
+  return octave_interrupt_state_gccjit > sig_atomic_type_gccjit.zero ();
+}
+#endif /* #ifdef HAVE_GCCJIT */
+
 
 void
 jit_typeinfo::add_builtin (const std::string& name)
 {
-  jit_type *btype = new_type (name, any, any->to_llvm (), true);
+  jit_type *btype = new_type (name, any, any->to_llvm (), any->to_gccjit (), true);
   builtins[name] = btype;
 
   octave_builtin *ov_builtin = find_builtin (name);
@@ -2077,6 +2796,19 @@
 
   llvm::Value *ret = builder.CreateCall (ifun, fargs);
   fn.do_return (builder, ret);
+
+  // gcc implementation
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::function builtin = gccjit_ctxt.get_builtin_function (name);
+    std::vector<gccjit::rvalue> gccjit_args (nargs);
+    for (size_t i = 0; i < nargs; ++i)
+      gccjit_args[i] = gf.get_param (i + 1);
+    gccjit::rvalue ret = gccjit_ctxt.new_call (builtin, gccjit_args);
+    gccjit::block b = gf.new_block ();
+    b.end_with_return (ret);
+  }
+
   paren_subsref_fn.add_overload (fn);
 }
 
@@ -2102,6 +2834,8 @@
   std::copy (args.begin (), args.end (), fn_args.begin () + 1);
   jit_function fn = create_internal (name, result, fn_args);
   fn.mark_can_error ();
+
+  // LLVM implementation:
   llvm::BasicBlock *block = fn.new_block ();
   builder.SetInsertPoint (block);
   llvm::Type *any_t = any->to_llvm ();
@@ -2132,6 +2866,53 @@
 
   jit_function cast_result = cast (result, any);
   fn.do_return (builder, cast_result.call (builder, ret));
+
+  // gccjit implementation:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ("body of register_generic");
+    b.add_comment ("TODO: register_generic");
+
+    gccjit::type array_t = gccjit_ctxt.new_array_type (any->to_gccjit (),
+                                                       args.size ());
+#if 1
+    gccjit::lvalue array = gf.new_local (array_t, "tmp_array");
+    for (size_t i = 0; i < args.size (); ++i)
+      {
+        gccjit::lvalue arg = gf.get_param (i + 1);
+        jit_function agrab = get_grab (args[i]);
+        if (agrab.valid ())
+          {
+            std::vector<gccjit::rvalue> grab_args (1, arg);
+            b.add_assignment (arg, agrab.call (gccjit_ctxt, b, grab_args));
+          }
+        jit_function acast = cast (any, args[i]);
+        std::vector<gccjit::rvalue> cast_args (1, arg);
+        b.add_assignment (array[i],
+                          acast.call (gccjit_ctxt, b, cast_args));
+      }
+#endif
+
+    gccjit::type int_t = intN (sizeof (octave_builtin::fcn) * 8)->to_gccjit ();
+    size_t fcn_int = reinterpret_cast<size_t> (builtin->function ());
+    gccjit::rvalue fcn = gccjit_ctxt.new_rvalue (int_t, (int)fcn_int);
+    gccjit::rvalue nargin = gccjit_ctxt.new_rvalue (int_t, (int)args.size ());
+    size_t result_int = reinterpret_cast<size_t> (result);
+    gccjit::rvalue res_gcc = gccjit_ctxt.new_rvalue (int_t, (int)result_int);
+    std::vector<gccjit::rvalue> call_args (4);
+    call_args[0] = fcn;
+    call_args[1] = nargin;
+    call_args[2] = array;
+    call_args[3] = res_gcc;
+    gccjit::rvalue ret = any_call.call (gccjit_ctxt, b, call_args);
+    
+    jit_function cast_result = cast (result, any);
+    std::vector<gccjit::rvalue> final_cast_args (1);
+    final_cast_args[0] = ret;
+    gccjit::rvalue final_result = cast_result.call (gccjit_ctxt, b, final_cast_args);
+    b.end_with_return (final_result);
+  }
+
   paren_subsref_fn.add_overload (fn);
 }
 
@@ -2144,6 +2925,7 @@
   if (fn.can_error ())
     ret.mark_can_error ();
 
+  // LLVM implementation:
   llvm::BasicBlock *body = ret.new_block ();
   builder.SetInsertPoint (body);
   llvm::Value *result = fn.call (builder, ret.argument (builder, 1),
@@ -2153,9 +2935,25 @@
   else
     ret.do_return (builder);
 
+  // gccjit implementation:
+  gccjit::function gf = ret.gccjit_function;
+  gccjit::block b = gf.new_block ();
+  b.add_comment ("built by mirror_binary");
+  //std::vector<gccjit::rvalue> gccjit_args (2);
+  //gccjit_args[0] = gf.get_param (1);
+  //gccjit_args[1] = gf.get_param (0);
+  if (ret.result ())
+    b.end_with_return (
+      gccjit_ctxt.new_call (fn.gccjit_function,
+                            gf.get_param (1),
+                            gf.get_param (0)));
+  else
+    b.end_with_return ();
+
   return ret;
 }
 
+#ifdef HAVE_LLVM
 llvm::Value *
 jit_typeinfo::pack_complex (llvm::IRBuilderD& bld, llvm::Value *cplx)
 {
@@ -2216,14 +3014,63 @@
   ret = complex_real (ret, real);
   return complex_imag (ret, imag);
 }
+#endif // #ifdef HAVE_LLVM
+
+#ifdef HAVE_GCCJIT
+gccjit::rvalue
+jit_typeinfo::complex_real (gccjit::rvalue cx)
+{
+  return cx[0];
+}
+
+gccjit::rvalue
+jit_typeinfo::complex_real (gccjit::block block,
+                            gccjit::lvalue cx,
+                            gccjit::rvalue real)
+{
+  block.add_assignment (cx[0], real);
+  return cx;
+}
+
+gccjit::rvalue
+jit_typeinfo::complex_imag (gccjit::rvalue cx)
+{
+  return cx[1];
+}
+
+gccjit::rvalue
+jit_typeinfo::complex_imag (gccjit::block block,
+                            gccjit::lvalue cx,
+                            gccjit::rvalue imag)
+{
+  block.add_assignment (cx[1], imag);
+  return cx;
+}
+
+gccjit::rvalue
+jit_typeinfo::complex_new (gccjit::block block,
+                           gccjit::rvalue real,
+                           gccjit::rvalue imag)
+{
+  gccjit::rvalue tmp =
+    block.get_function ().new_local (complex->to_gccjit (),
+                                     "complex_new");
+  block.add_assignment (tmp[0], real);
+  block.add_assignment (tmp[1], imag);
+  return tmp;
+}
+#endif // #ifdef HAVE_GCCJIT
 
 void
 jit_typeinfo::create_int (size_t nbits)
 {
   std::stringstream tname;
   tname << "int" << nbits;
-  ints[nbits] = new_type (tname.str (), any, llvm::Type::getIntNTy (context,
-                                                                    nbits));
+  ints[nbits] = new_type (tname.str (), any,
+                          llvm::Type::getIntNTy (context,
+                                                 nbits),
+                          gccjit_ctxt.get_int_type (nbits / 8, 1)
+                          );
 }
 
 jit_type *
